/// <reference types="node" />
import { CommandUtil } from "../interfaces/command-util";
import { IPostal } from "../interfaces/postal";
import { ProgressBar } from "../interfaces/progress-bar";
export declare class CommandUtilImpl implements CommandUtil {
    private postal;
    private progressBar;
    private _console;
    private exitHandler(options, err);
    private registerProcessManagementEvents();
    constructor(_postal: IPostal, _progressBar: ProgressBar);
    stderrWrite(msg: string): void;
    stdoutWrite(msg: string): void;
    private stderrLog(msg);
    private stdoutLog(msg);
    returnErrorStringOrMessage(err: Error, message: string): string;
    error(msg: string): void;
    log(msg: string): void;
    logErrors(errs: Error[], writeErrorToConsole?: boolean): string[];
    logError(err: Error, writeErrorToConsole?: boolean): string;
    processExitWithError(err: Error, nonErrorMessage?: string): void;
    processExit(exitCode?: number, msg?: string): void;
    callbackIfError(cb: (err: Error, result: any) => void, err?: Error, result?: any): boolean;
    logAndCallback(msg: string, cb: (err: Error, result: any) => void, err?: Error, result?: any): boolean;
    getConfigFilePath(filename: string, extension?: string): string;
}
